Package com.io7m.idstore.model

# Class IdAdminPermissionSet

java.lang.Object
com.io7m.idstore.model.IdAdminPermissionSet

public final class IdAdminPermissionSet extends Object
A set of permissions.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static IdAdminPermissionSet`
  `all()`
  `static IdAdminPermissionSet`
  `empty()`
  `boolean`
  `equals(Object o)`
  `int`
  `hashCode()`
  `Set<IdAdminPermission>`
  `impliedPermissions()`
  `boolean`
  `implies(IdAdminPermission permission)`
  `boolean`
  `impliesAll(Collection<IdAdminPermission> permissions)`
  `IdAdminPermissionSet`
  `minus(IdAdminPermission permission)`
  Construct a set of permissions based on this set.
  `static IdAdminPermissionSet`
  `of(IdAdminPermission... permissions)`
  Construct a set of permissions.
  `static IdAdminPermissionSet`
  `of(Set<IdAdminPermission> permissions)`
  Construct a set of permissions.
  `static IdAdminPermissionSet`
  `parse(String text)`
  Construct a set of permissions based on the given string.
  `IdAdminPermissionSet`
  `plus(IdAdminPermission permission)`
  Construct a set of permissions based on this set.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### empty

    public static IdAdminPermissionSet empty()
    Returns:
      The empty set of permissions

  - ### all

    public static IdAdminPermissionSet all()
    Returns:
      The set of permissions containing every permission

  - ### of

    public static IdAdminPermissionSet of(Set<IdAdminPermission> permissions)
    Construct a set of permissions.
    Parameters:
      `permissions` - The permissions
    Returns:
      A set of permissions

  - ### of

    public static IdAdminPermissionSet of(IdAdminPermission... permissions)
    Construct a set of permissions.
    Parameters:
      `permissions` - The permissions
    Returns:
      A set of permissions

  - ### plus

    public IdAdminPermissionSet plus(IdAdminPermission permission)
    Construct a set of permissions based on this set.
    Parameters:
      `permission` - The permission to add
    Returns:
      A set of permissions

  - ### minus

    public IdAdminPermissionSet minus(IdAdminPermission permission)
    Construct a set of permissions based on this set.
    Parameters:
      `permission` - The permission to remove
    Returns:
      A set of permissions

  - ### implies

    public boolean implies(IdAdminPermission permission)
    Parameters:
      `permission` - The permission
    Returns:
      `true` if this set implies the given permission

  - ### parse

    public static IdAdminPermissionSet parse(String text)
    Construct a set of permissions based on the given string. Unrecognized permissions will be ignored.
    Parameters:
      `text` - The permission string
    Returns:
      A set of permissions

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### impliedPermissions

    public Set<IdAdminPermission> impliedPermissions()
    Returns:
      The set of implied permissions

  - ### impliesAll

    public boolean impliesAll(Collection<IdAdminPermission> permissions)
    Parameters:
      `permissions` - The permissions to check
    Returns:
      `true` if this set implies all the given permissions